'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.styleSheet = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

exports.default = CardHeader;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _jssThemeReactor = require('jss-theme-reactor');

var _customPropTypes = require('../utils/customPropTypes');

var _customPropTypes2 = _interopRequireDefault(_customPropTypes);

var _Text = require('../Text');

var _Text2 = _interopRequireDefault(_Text);

var _CardContent = require('./CardContent');

var _CardContent2 = _interopRequireDefault(_CardContent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styleSheet = exports.styleSheet = (0, _jssThemeReactor.createStyleSheet)('MuiCardHeader', function () {
  return {
    cardHeader: {
      display: 'flex',
      alignItems: 'center'
    },
    avatar: {
      flex: '0 0 auto',
      marginRight: 16
    },
    content: {
      flex: '1 1 auto'
    },
    contentSecondary: {
      lineHeight: 1
    }
  };
}); //  weak

function CardHeader(props, context) {
  var avatar = props.avatar,
      classNameProp = props.className,
      subheader = props.subheader,
      title = props.title,
      other = (0, _objectWithoutProperties3.default)(props, ['avatar', 'className', 'subheader', 'title']);


  var classes = context.styleManager.render(styleSheet);
  var className = (0, _classnames2.default)(classes.cardHeader, classNameProp);

  if (avatar) {
    return _react2.default.createElement(
      _CardContent2.default,
      (0, _extends3.default)({ className: className }, other),
      _react2.default.createElement(
        'div',
        { className: classes.avatar },
        avatar
      ),
      _react2.default.createElement(
        'div',
        { className: classes.content },
        _react2.default.createElement(
          _Text2.default,
          { type: 'body2', gutterBottom: true },
          title
        ),
        _react2.default.createElement(
          _Text2.default,
          { type: 'body2', secondary: true, className: classes.contentSecondary },
          subheader
        )
      )
    );
  }

  return _react2.default.createElement(
    _CardContent2.default,
    (0, _extends3.default)({ className: className }, other),
    _react2.default.createElement(
      _Text2.default,
      { type: 'headline' },
      title
    ),
    _react2.default.createElement(
      _Text2.default,
      { type: 'body1', secondary: true },
      subheader
    )
  );
}

process.env.NODE_ENV !== "production" ? CardHeader.propTypes = {
  /**
   * The Avatar  for the Card Header.
   */
  avatar: _propTypes2.default.node,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes2.default.string,
  /**
   * The content of the component.
   */
  subheader: _propTypes2.default.node,
  /**
   * The content of the Card Title.
   */
  title: _propTypes2.default.node
} : void 0;

CardHeader.contextTypes = {
  styleManager: _customPropTypes2.default.muiRequired
};